#!/usr/bin/twistd -y
#
# This is the code needed to run the DSPAM CGI as a standalone
# web server. This allow us to run DSPAM with special uid dspam
# (see http://mathiasson.nu/trac/wiki/docs/dspam)

import os
from twisted.application import service, internet
from twisted.web import static, server, resource, twcgi, error

# Import config
execfile("/etc/dspam/webui.conf")

class Root(resource.Resource):
    def getChildWithDefault(self, path, request):
	"""Verify proxy password and set environment."""

	if globals().has_key('PROXY_PASSWORD'):
	    if not request.received_headers.has_key("proxy-password") or \
	    request.received_headers["proxy-password"] != PROXY_PASSWORD:
		return error.ErrorPage(403, "Forbidden", "403 Invalid proxy password")

	# twcgi does not pass REMOTE_USER to CGI scripts, which dspam.cgi expects
	u = request.getUser()
	if u:
	    os.environ["REMOTE_USER"] = u
	elif os.environ.has_key("REMOTE_USER"):
	    del os.environ["REMOTE_USER"]

	return resource.Resource.getChildWithDefault(self, path, request)

def getWebService():
    """Return a service suitable for creating an application object."""

    root = Root()
    root.putChild("htdocs", static.File(STATIC_DIR))
    root.putChild("cgi-bin", twcgi.CGIDirectory(CGI_DIR))

    # Create a resource to serve files
    webServer = server.Site(root)

    if globals().has_key('LISTEN'):
	return internet.TCPServer(HTTP_PORT, webServer, interface=LISTEN)
    else:
	return internet.TCPServer(HTTP_PORT, webServer)

# Create the root-level application object
application = service.Application("dspamwebd")

# Attach the service to its parent application
service = getWebService()
service.setServiceParent(application)
